Get Rates for Shipment [STREAM]
Fetch available shipping rates for a shipment via stream endpoint.
/rates/stream
GET https://api.terminal.africa/v1/rates/shipment/stream
This endpoint allows you to retrieve rates for a shipment via a stream for improved performance. For more information on streaming apis, see here. This endpoint can be used for single or multi-piece shipments.
To return cash on delivery rates for carriers who supports cash-on-delivery, set cash_on_delivery to true if shipment_id does not include a shipment_type of cash-on-delivery.
Rate streaming response handling works a bit differently from your standard rates api, for an example of how to fetch rates using this api please see
Query Parameters
currency
string
Currency for rates. Defaults to NGN. Available options are AED, AUD, CAD, CNY, EUR, GBP, GHS, HKD, KES, NGN, TZS, UGX, USD, ZAR.
pickup_address
string
Unique id for pickup address. Required if shipment_id not provided.
delivery_address
string
Unique id for delivery address. Required if shipment_id not provided.
shipment_id
string
Unique id of shipment. Required if delivery_address and pickup_address not provided.
parcel_id
string
Unique id of parcel. Not required if shipment id is provided.
parcel_ids
string
Unique list of parcel ids. Not required if shipment id is provided.
cash_on_delivery
boolean
Set to true to return rates for carriers who supports cash-on-delivery
Headers
Authorization*
string
Set value to Bearer SECRET_KEY
{
"type": "start",
"carriers": [
"gokada",
"store-pickup",
"kwik",
"ups",
"ship-to-naija",
"topship",
"darum",
"gigl",
"get-messenger",
"dhl-ng",
"sendstack",
"dellyman",
"redstar",
"qc-express",
"fez-delivery"
]
}{
"type": "carrier",
"carrier_slug": "redstar",
"carrier_name": "Redstar Express",
"rates": [
{
"carrier_logo": "https://terminal-static-file.s3.us-east-1.amazonaws.com/images/Redstar.svg",
"carrier_name": "Redstar Express",
"carrier_reference": "CA-EPTEBPNPW7HWULW0",
"carrier_slug": "redstar",
"currency": "NGN",
"insurance_coverage": 0,
"insurance_fee": 0,
"includes_insurance": false,
"includes_duties": false,
"metadata": {
"default_parcel": {
"packaging_dimension": {
"length": 10,
"height": 1,
"width": 10
},
"parcel_total_weight": 2,
"parcel_value": 20000,
"packages": [
{
"weight": 2,
"dimensions": {
"length": 10,
"width": 10,
"height": 1
}
}
]
},
"address_payload": {
"pickup_address": {
"city": "Ikeja",
"state": "Lagos",
"country": "NG",
"zip": "121006"
},
"delivery_address": {
"city": "Ikeja",
"state": "Lagos",
"country": "NG",
"zip": "121006"
}
},
"true_weight": 2,
"score": 0,
"avgRating": 0,
"insurance_fee": 0,
"insurance_currency": "NGN",
"insurance_default_fee": 0,
"insurance_default_currency": "NGN",
"cod_processing_fee": 0,
"shipment_service_charge": 300,
"shipment_items": [
{
"name": "Invoices and Trade Documents",
"description": "Invoices and Trade Documents",
"hs_code": "4911998000",
"hs_code_id": "",
"quantity": 1,
"value": 10000,
"weight": 1,
"currency": "NGN",
"type": "document",
"manufacturer_country": "NG"
},
{
"name": "Eye make-up preparations",
"description": "Eye make-up preparations",
"hs_code": "3304200000",
"hs_code_id": "HS-VGIZLSP0F7IU8QNM",
"quantity": 1,
"value": 10000,
"weight": 1,
"currency": "NGN",
"type": "parcel",
"manufacturer_country": "NG"
}
]
},
"pickup_available": true,
"user": "USER-27450202164",
"pickup_address": "AD-CJABDZV5H2IBE9Y5",
"delivery_address": "AD-Q3191G2Y13DJ0DRW",
"parcel": "PC-A7QJ2GMR3L5M65L3",
"amount": 3622.32,
"default_amount": 3622.32,
"default_currency": "NGN",
"carrier_rate_description": "Normal Delivery",
"delivery_date": "2026-05-17T09:36:49.530Z",
"delivery_eta": 7200,
"delivery_time": "Within 4 business days",
"id": "rate_xEmyg9hZWFsdWFOK",
"pickup_date": "2026-05-13T09:36:49.530Z",
"pickup_eta": 1440,
"pickup_time": "Within 24 Hours",
"rate_id": "RT-9KFR7MWCQFIO96NU",
"supports_duty": false,
"requires_duty": false,
"regulatory_documents": []
}
]
}Last updated
Was this helpful?